/***************************************************************************
 *   Copyright Brian Ledbetter 2001-2003 <brian@shadowcom.net>             *
 *   Copyright Ravikiran Rajagopal 2003                                    *
 *   ravi@ee.eng.ohio-state.edu                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License (version 2) as   *
 *   published by the Free Software Foundation. (The original KSplash/ML   *
 *   codebase (upto version 0.95.3) is BSD-licensed.)                      *
 *                                                                         *
 ***************************************************************************/

#ifndef __ICON_H__
#define __ICON_H__

#include <kpixmap.h>

#include <qhbox.h>

/*
 * @short This class will draw an icon along an edge of the screen, ala MacOS. Unlike
 * Steve Jobs' completely non-customizable OS, you _can_ adjust the way this program
 * behaves...
 */
class Icon:
      public QHBox
{
  Q_OBJECT
public:

  enum Position {
    HBottomLeft = 0,
    HBottomRight = 1,
    HTopLeft = 2,
    HTopRight = 3,
    VBottomLeft = 10,
    VBottomRight = 11,
    VTopLeft = 12,
    VTopRight = 13
  };

  Icon( unsigned int, unsigned int, const KPixmap&, const QString&, Position, bool );

signals:
  void setStatusText( const QString& );

public slots:
  void show();
  void noshow();
  void slotStopJumping();
  void slotJump();

private:
  QPoint determinePosition();

protected:
  QString mStatusText;
  Position mIconPos;
  int mPosX, mPosY, mGroundX, mGroundY;
  float mVelocity, mInitialVelocity, mGravity;
  int mIconNum, mStatusHeight, mIconSize;
  bool mStatusAtTop, mStopJump, mIconJumping;
};

#endif
